/*
 * PageSize.java
 *
 *  iReport  --  Visual designer for generating JasperReports Documents
 *  Copyright (C) 2002  Giulio Toffoli gt@businesslogic.it
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Giulio Toffoli
 *  Via T.Aspetti, 233
 *  35100 Padova ITALY
 *  gt@businesslogic.it
 *
 * Created on 8 febbraio 2003, 18.20
 */

package it.businesslogic.ireport.util;


import java.awt.*;

public class PageSize
{
/** This is the letter format */
    public static final Point LETTER = new Point(612,792);
    
/** This is the note format */
    public static final Point NOTE = new Point(540,720);
    
/** This is the legal format */
    public static final Point LEGAL = new Point(612,1008);
    
/** This is the a0 format */
    public static final Point A0 = new Point(2380,3368);
    
/** This is the a1 format */
    public static final Point A1 = new Point(1684,2380);
    
/** This is the a2 format */
    public static final Point A2 = new Point(1190,1684);
    
/** This is the a3 format */
    public static final Point A3 = new Point(842,1190);
    
/** This is the a4 format */
    public static final Point A4 = new Point(595,842);
    
/** This is the a5 format */
    public static final Point A5 = new Point(421,595);
    
/** This is the a6 format */
    public static final Point A6 = new Point(297,421);
    
/** This is the a7 format */
    public static final Point A7 = new Point(210,297);
    
/** This is the a8 format */
    public static final Point A8 = new Point(148,210);
    
/** This is the a9 format */
    public static final Point A9 = new Point(105,148);
    
/** This is the a10 format */
    public static final Point A10 = new Point(74,105);
    
/** This is the b0 format */
    public static final Point B0 = new Point(2836,4008);
    
/** This is the b1 format */
    public static final Point B1 = new Point(2004,2836);
    
/** This is the b2 format */
    public static final Point B2 = new Point(1418,2004);
    
/** This is the b3 format */
    public static final Point B3 = new Point(1002,1418);
    
/** This is the b4 format */
    public static final Point B4 = new Point(709,1002);
    
/** This is the b5 format */
    public static final Point B5 = new Point(501,709);
    
/** This is the archE format */
    public static final Point ARCH_E = new Point(2592,3456);
    
/** This is the archD format */
    public static final Point ARCH_D = new Point(1728,2592);
    
/** This is the archC format */
    public static final Point ARCH_C = new Point(1296,1728);
    
/** This is the archB format */
    public static final Point ARCH_B = new Point(864,1296);
    
/** This is the archA format */
    public static final Point ARCH_A = new Point(648,864);
    
/** This is the flsa format */
    public static final Point FLSA = new Point(612,936);
    
/** This is the flse format */
    public static final Point FLSE = new Point(612,936);
    
/** This is the halfletter format */
    public static final Point HALFLETTER = new Point(396,612);
    
/** This is the 11x17 format */
    public static final Point _11X17 = new Point(792,1224);
    
/** This is the ledger format */
    public static final Point LEDGER = new Point(1224,792);
    
    public static Point getFormatSize(String format)
    {
        if (format == null) return A4;
        if (format.equals("LETTER")) return LETTER;
        if (format.equals("NOTE")) return NOTE;
        if (format.equals("LEGAL")) return LEGAL;
        if (format.equals("A0")) return A0;
        if (format.equals("A1")) return A1;
        if (format.equals("A2")) return A2;
        if (format.equals("A3")) return A3;
        if (format.equals("A4")) return A4;
        if (format.equals("A5")) return A5;
        if (format.equals("A6")) return A6;
        if (format.equals("A7")) return A7;
        if (format.equals("A8")) return A8;
        if (format.equals("A9")) return A9;
        if (format.equals("A10")) return A10;
        if (format.equals("B0")) return B0;
        if (format.equals("B1")) return B1;
        if (format.equals("B2")) return B2;
        if (format.equals("B3")) return B3;
        if (format.equals("B4")) return B4;
        if (format.equals("B5")) return B5;
        if (format.equals("ARCH_E")) return ARCH_E;
        if (format.equals("ARCH_D")) return ARCH_D;
        if (format.equals("ARCH_C")) return ARCH_C;
        if (format.equals("ARCH_B")) return ARCH_B;
        if (format.equals("ARCH_A")) return ARCH_A;
        if (format.equals("FLSA")) return FLSA;
        if (format.equals("FLSE")) return FLSE;
        if (format.equals("HALFLETTER")) return HALFLETTER;
        if (format.equals("11x17")) return _11X17;
        if (format.equals("LEDGER")) return LEDGER;
        
        return A4; // An european default... :-)
    }
}

